/******************************************************************************/
/* SISTEMAS INTEGRADOS TECNISA                                                */
/*                                                                            */
/* COMPRAS E SUPRIMENTOS                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* NOME: GRAVA_LOGITEMCOLE                                                    */
/*                                                                            */
/* DESCRIO:                                                                 */
/*   Grava log de item de cotao                                             */
/*                                                                            */
/* CRIAO:                                                                   */
/* 24/12/2003 - Adriano de Arajo                                             */
/*                                                                            */
/******************************************************************************/

/*
@C:\WEB_410\Sql\End_Conv\Oracle\8750_SUPTRGO_GRAVA_LOGITEMCOLE.SQL
*/

CREATE OR REPLACE TRIGGER GRAVA_LOGITEMCOLE
BEFORE INSERT OR UPDATE OR DELETE
ON ITEMCOLE FOR EACH ROW

DECLARE

  V_IDGRAVLOGCOT  VARCHAR2(03);
  V_DSREMOTEADDR  VARCHAR2(50);
  V_DSREMOTEHOST  VARCHAR2(50);
  V_DSSERVERRDM   VARCHAR2(50);
  V_DSMETUSULIC   VARCHAR2(50);
  V_CDOPERLIC     VARCHAR2(12);

BEGIN
   SELECT NVL(MAX(IDGRAVLOGCOT), 'SSS')
   INTO V_IDGRAVLOGCOT
   FROM PARASUPRI
   WHERE CDFILIAL = NVL(:NEW.CDFILIAL, :OLD.CDFILIAL);

   WEBTUNNING(V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVERRDM, V_DSMETUSULIC, V_CDOPERLIC);

   IF INSERTING THEN
      IF :NEW.VRPRECUNIITM = 0 THEN
         INSERT INTO LOGITEMCOLE
         (CDFILIALLIC,  NRCOLEPRELIC, CDMARCALIC,
          CDREGIAOLIC,  CDFORNECELIC, CDPRODUTOLIC,
          DTINIVALLIC,  DTFINVALLIC,  VRPRECANTLIC,
          VRPRECDEPLIC, DTOPERACLIC,  DSENDUSULIC,
          DSNMUSULIC,   DSRDMUSULIC, DSMETUSULIC, IDOPERALIC, CDOPERLIC,
          IDITMLISPLIC, NRCOLEORILIC, DTINCLITMLIC,
          IDATUREINLIC, IDATUREALLIC, CDOPERINCLIC,IDATUFOINLIC,IDATUFOALLIC,
          VRPRECECOLIC, VRPRECOPILIC, CDFORMPGTLIC)
        VALUES
         (:NEW.CDFILIAL,     :NEW.NRCOLEPRECO, :NEW.CDMARCA,
          :NEW.CDREGIAO,     :NEW.CDFORNECED,  :NEW.CDPRODUTO,
          :NEW.DTINIVALITM,  :NEW.DTFINVALITM, 0,
          :NEW.VRPRECUNIITM, SYSDATE,          V_DSREMOTEADDR,
          V_DSREMOTEHOST,    V_DSSERVERRDM, V_DSMETUSULIC,   'I', V_CDOPERLIC,
          :NEW.IDITMLISPREC, :NEW.NRCOLEORIGIC, :NEW.DTINCLITMCOL,
          :NEW.IDATUREGIINC, :NEW.IDATUREGIALT, :NEW.CDOPERINCL, :NEW.IDATUFORNINC,:NEW.IDATUFORNALT,
          :NEW.VRPRECECOITM, :NEW.VRPRECOITMPI, :NEW.CDFORMPGTO);
       END IF;
   END IF;

   IF UPDATING THEN
      IF SUBSTR(V_IDGRAVLOGCOT, 2, 1) = 'S' THEN
         IF (:NEW.VRPRECUNIITM <> :OLD.VRPRECUNIITM) THEN
            INSERT INTO LOGITEMCOLE
             (CDFILIALLIC,  NRCOLEPRELIC, CDMARCALIC,
              CDREGIAOLIC,  CDFORNECELIC, CDPRODUTOLIC,
              DTINIVALLIC,  DTFINVALLIC,  VRPRECANTLIC,
              VRPRECDEPLIC, DTOPERACLIC,  DSENDUSULIC,
              DSNMUSULIC,   DSRDMUSULIC,  DSMETUSULIC, IDOPERALIC, CDOPERLIC,
              IDITMLISPLIC, NRCOLEORILIC, DTINCLITMLIC,
              IDATUREINLIC, IDATUREALLIC, CDOPERINCLIC,IDATUFOINLIC,IDATUFOALLIC,
              VRPRECECOLIC, VRPRECOPILIC, CDFORMPGTLIC)
            VALUES
             (:OLD.CDFILIAL,     :OLD.NRCOLEPRECO, :OLD.CDMARCA,
              :OLD.CDREGIAO,     :OLD.CDFORNECED,  :OLD.CDPRODUTO,
              :NEW.DTINIVALITM,  :NEW.DTFINVALITM, :OLD.VRPRECUNIITM,
              :NEW.VRPRECUNIITM, SYSDATE,          V_DSREMOTEADDR,
              V_DSREMOTEHOST,    V_DSSERVERRDM,    V_DSMETUSULIC,  'A', V_CDOPERLIC,
              :NEW.IDITMLISPREC, :NEW.NRCOLEORIGIC, :NEW.DTINCLITMCOL,
              :NEW.IDATUREGIINC, :NEW.IDATUREGIALT, :NEW.CDOPERINCL, :NEW.IDATUFORNINC,:NEW.IDATUFORNALT,
              :NEW.VRPRECECOITM, :NEW.VRPRECOITMPI, :NEW.CDFORMPGTO);
         ELSE
            IF ((:NEW.NRSEQPRELIST IS NOT NULL) AND (:OLD.NRSEQPRELIST IS NULL)) THEN
               INSERT INTO LOGITEMCOLE
                (CDFILIALLIC,  NRCOLEPRELIC, CDMARCALIC,
                 CDREGIAOLIC,  CDFORNECELIC, CDPRODUTOLIC,
                 DTINIVALLIC,  DTFINVALLIC,  VRPRECANTLIC,
                 VRPRECDEPLIC, DTOPERACLIC,  DSENDUSULIC,
                 DSNMUSULIC,   DSRDMUSULIC,  DSMETUSULIC, IDOPERALIC, CDOPERLIC,
                 IDITMLISPLIC, NRCOLEORILIC, DTINCLITMLIC,
                 IDATUREINLIC, IDATUREALLIC, CDOPERINCLIC,IDATUFOINLIC,IDATUFOALLIC, IDENTSAILIST, NRPRELISTLIC,
                 VRPRECECOLIC, VRPRECOPILIC, CDFORMPGTLIC)
               VALUES
                (:OLD.CDFILIAL,     :OLD.NRCOLEPRECO, :OLD.CDMARCA,
                 :OLD.CDREGIAO,     :OLD.CDFORNECED,  :OLD.CDPRODUTO,
                 :NEW.DTINIVALITM,  :NEW.DTFINVALITM, :OLD.VRPRECUNIITM,
                 :NEW.VRPRECUNIITM, SYSDATE,          V_DSREMOTEADDR,
                 V_DSREMOTEHOST,    V_DSSERVERRDM,    V_DSMETUSULIC,  'A', V_CDOPERLIC,
                 :NEW.IDITMLISPREC, :NEW.NRCOLEORIGIC, :NEW.DTINCLITMCOL,
                 :NEW.IDATUREGIINC, :NEW.IDATUREGIALT, :NEW.CDOPERINCL, :NEW.IDATUFORNINC,:NEW.IDATUFORNALT, '1', :NEW.NRSEQPRELIST,
                 :NEW.VRPRECECOITM, :NEW.VRPRECOITMPI, :NEW.CDFORMPGTO);
            ELSE
               IF ((:NEW.NRSEQPRELIST IS NULL) AND (:OLD.NRSEQPRELIST IS NOT NULL)) THEN
                  INSERT INTO LOGITEMCOLE
                   (CDFILIALLIC,  NRCOLEPRELIC, CDMARCALIC,
                    CDREGIAOLIC,  CDFORNECELIC, CDPRODUTOLIC,
                    DTINIVALLIC,  DTFINVALLIC,  VRPRECANTLIC,
                    VRPRECDEPLIC, DTOPERACLIC,  DSENDUSULIC,
                    DSNMUSULIC,   DSRDMUSULIC,  DSMETUSULIC, IDOPERALIC, CDOPERLIC,
                    IDITMLISPLIC, NRCOLEORILIC, DTINCLITMLIC,
                    IDATUREINLIC, IDATUREALLIC, CDOPERINCLIC,IDATUFOINLIC,IDATUFOALLIC, IDENTSAILIST, NRPRELISTLIC,
                    VRPRECECOLIC, VRPRECOPILIC, CDFORMPGTLIC)
                  VALUES
                   (:OLD.CDFILIAL,     :OLD.NRCOLEPRECO, :OLD.CDMARCA,
                    :OLD.CDREGIAO,     :OLD.CDFORNECED,  :OLD.CDPRODUTO,
                    :NEW.DTINIVALITM,  :NEW.DTFINVALITM, :OLD.VRPRECUNIITM,
                    :NEW.VRPRECUNIITM, SYSDATE,          V_DSREMOTEADDR,
                    V_DSREMOTEHOST,    V_DSSERVERRDM,    V_DSMETUSULIC,  'A', V_CDOPERLIC,
                   :NEW.IDITMLISPREC, :NEW.NRCOLEORIGIC, :NEW.DTINCLITMCOL,
                   :NEW.IDATUREGIINC, :NEW.IDATUREGIALT, :NEW.CDOPERINCL, :NEW.IDATUFORNINC,:NEW.IDATUFORNALT, '2', :OLD.NRSEQPRELIST,
                   :NEW.VRPRECECOITM, :NEW.VRPRECOITMPI, :NEW.CDFORMPGTO);
               END IF;
            END IF;
         END IF;
      END IF;
   END IF;

   IF DELETING THEN
      IF SUBSTR(V_IDGRAVLOGCOT, 3, 1) = 'S' THEN
         INSERT INTO LOGITEMCOLE
          (CDFILIALLIC,  NRCOLEPRELIC, CDMARCALIC,
           CDREGIAOLIC,  CDFORNECELIC, CDPRODUTOLIC,
           DTINIVALLIC,  DTFINVALLIC,  VRPRECANTLIC,
           VRPRECDEPLIC, DTOPERACLIC,  DSENDUSULIC,
           DSNMUSULIC,   DSRDMUSULIC,  DSMETUSULIC, IDOPERALIC, CDOPERLIC,
           IDITMLISPLIC, NRCOLEORILIC, DTINCLITMLIC,
           IDATUREINLIC, IDATUREALLIC, CDOPERINCLIC, IDATUFOINLIC,IDATUFOALLIC,
           VRPRECECOLIC, VRPRECOPILIC, CDFORMPGTLIC)
         VALUES
          (:OLD.CDFILIAL,    :OLD.NRCOLEPRECO, :OLD.CDMARCA,
           :OLD.CDREGIAO,    :OLD.CDFORNECED,  :OLD.CDPRODUTO,
           :OLD.DTINIVALITM, :OLD.DTFINVALITM, :OLD.VRPRECUNIITM,
           0,                SYSDATE,          V_DSREMOTEADDR,
           V_DSREMOTEHOST,   V_DSSERVERRDM,    V_DSMETUSULIC, 'E', V_CDOPERLIC,
           :OLD.IDITMLISPREC, :OLD.NRCOLEORIGIC, :OLD.DTINCLITMCOL,
           :OLD.IDATUREGIINC, :OLD.IDATUREGIALT, :OLD.CDOPERINCL, :OLD.IDATUFORNINC,:OLD.IDATUFORNALT,
           :OLD.VRPRECECOITM, :OLD.VRPRECOITMPI, :OLD.CDFORMPGTO);
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GRAVA_LOGITEMCOLE','4.11.076'); END;
/

