IF EXISTS (SELECT *
             FROM sysobjects O, sysusers U
            WHERE o.name = 'CANCELA_EXPORTA_PDV_FINANC'
              AND type   = 'P'
              AND u.uid  = o.uid
              AND u.name = USER)

   DROP PROCEDURE CANCELA_EXPORTA_PDV_FINANC;
GO

CREATE PROCEDURE CANCELA_EXPORTA_PDV_FINANC(
   @P_CDFILIAL     VARCHAR(4), /*CDFILIALNF da MOVCAIXA*/
   @P_NRLANCTONF   VARCHAR(10)) /*NRLANCTONF da MOVCAIXA*/
AS
   DECLARE @V_CDEMPRESA     VARCHAR(2);
   DECLARE @V_CDFIMOVFLREC  VARCHAR(4);
   DECLARE @V_DTATUAVENREC  DATETIME;
   DECLARE @V_IDMOVFLUXO    VARCHAR(1);
   DECLARE @V_CDCLASSFINA   VARCHAR(6);
   DECLARE @V_VRORIGREC     NUMERIC(15,2);
   DECLARE @V_VRAJUSTE      NUMERIC(15,2);
   DECLARE @V_IDAJUCTREC    VARCHAR(1);

   DECLARE @V_NRCHEQUEVEND VARCHAR(6);
   DECLARE @V_CDBANCHEQVEN VARCHAR(3);
   DECLARE @V_CDAGECHEQVEN VARCHAR(5);
   DECLARE @V_CDCNTCHEQVEN VARCHAR(16);

   /*VARIRVEIS PARA O CURSOR DE AJUSTE*/
   DECLARE @V_AJCNT_CDFILIAL VARCHAR(4);
   DECLARE @V_AJCNT_NRLANCTONF VARCHAR(10);
   DECLARE @V_AJCNT_NRSEQVENREC VARCHAR(2);
   DECLARE @V_AJCNT_NRPARCELAREC VARCHAR(2);
   DECLARE @V_AJCNT_DTAJUSTEREC DATETIME;
   DECLARE @V_AJCNT_CDAJUCTREC VARCHAR(4);
   DECLARE @V_AJCNT_IDAJUCTREC VARCHAR(1);
   DECLARE @V_AJCNT_VRAJUSTEREC NUMERIC(15, 2);
   DECLARE @V_AJCNT_CDCLASSFINA VARCHAR(6);
   DECLARE @V_AJCNT_CDEMFAJCNTR VARCHAR(2);
   DECLARE @V_AJCNT_CDFIMFAJCNTR VARCHAR(4);
   DECLARE @V_AJCNT_DTMOVFLUXO DATETIME;
   DECLARE @V_AJCNT_IDMOVFLUXO VARCHAR(1);

   DECLARE @V_VALORCALCULADO NUMERIC(15, 2);

   /*VARIVEIS PARA O CURSOR DE BOLETOS*/
   DECLARE @V_BOLETOS_CDFILIBOLREC VARCHAR(4);
   DECLARE @V_BOLETOS_NRLANBOLREC VARCHAR(10);
   DECLARE @V_BOLETOS_CDFILIAL VARCHAR(4);
   DECLARE @V_BOLETOS_NRSEQVENREC VARCHAR(2);
   DECLARE @V_BOLETOS_NRPARCELAREC VARCHAR(2);
   DECLARE @V_BOLETOS_CDEMPRESA VARCHAR(2);
   DECLARE @V_BOLETOS_CDFIMOVFLREC VARCHAR(4);
   DECLARE @V_BOLETOS_CDCLASSFINA VARCHAR(6);
   DECLARE @V_BOLETOS_DTMOVFLUXO DATETIME;
   DECLARE @V_BOLETOS_IDMOVFLUXO VARCHAR(1);

   /*VARIVEIS DO CURSOR C_AJUSTEBOL*/
   DECLARE @V_AJUSTEBOL_CDFILIAL VARCHAR(4);
   DECLARE @V_AJUSTEBOL_NRLANBOLREC VARCHAR(10);
   DECLARE @V_AJUSTEBOL_CDAJUCTREC VARCHAR(4);
   DECLARE @V_AJUSTEBOL_VRAJBOLREC NUMERIC(15,2);

   DECLARE @V_NRLANCTBDOC VARCHAR(12);
   DECLARE @V_AJCNT_CDECTBAJREC VARCHAR(02);
   DECLARE @V_AJCNT_NRLCTBAJREC VARCHAR(12);
BEGIN
   /*Deleta os ajustes da conta*/
   DECLARE C_AJUSTECNT CURSOR FOR
   SELECT A.CDFILIAL,    A.NRLANCTONF,   A.NRSEQVENREC,  A.NRPARCELAREC,
          A.DTAJUSTEREC, A.CDAJUCTREC,   T.IDAJUCTREC,   A.VRAJUSTEREC,
          A.CDCLASSFINA, A.CDEMMFAJCNTR, A.CDFIMFAJCNTR, A.DTMOVFLUXO,
          A.IDMOVFLUXO,  A.CDECTBAJREC,  A.NRLCTBAJREC
     FROM AJCTRECEBER A, TIPOAJRECEBER T
    WHERE (A.CDFILIAL   = @P_CDFILIAL)
      AND (A.NRLANCTONF = @P_NRLANCTONF)
      AND (A.CDAJUCTREC = T.CDAJUCTREC);
   OPEN C_AJUSTECNT;
   FETCH NEXT FROM C_AJUSTECNT INTO
   @V_AJCNT_CDFILIAL,
   @V_AJCNT_NRLANCTONF,
   @V_AJCNT_NRSEQVENREC,
   @V_AJCNT_NRPARCELAREC,
   @V_AJCNT_DTAJUSTEREC,
   @V_AJCNT_CDAJUCTREC,
   @V_AJCNT_IDAJUCTREC,
   @V_AJCNT_VRAJUSTEREC,
   @V_AJCNT_CDCLASSFINA,
   @V_AJCNT_CDEMFAJCNTR,
   @V_AJCNT_CDFIMFAJCNTR,
   @V_AJCNT_DTMOVFLUXO,
   @V_AJCNT_IDMOVFLUXO,
   @V_AJCNT_IDMOVFLUXO,
   @V_AJCNT_CDECTBAJREC,
   @V_AJCNT_NRLCTBAJREC;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF (@V_AJCNT_IDAJUCTREC = 'A') BEGIN
         SET @V_VALORCALCULADO = @V_AJCNT_VRAJUSTEREC * -1;
         EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJCNT_CDEMFAJCNTR,
                                      @V_AJCNT_CDFIMFAJCNTR,
                                      @V_AJCNT_DTMOVFLUXO,
                                      @V_AJCNT_IDMOVFLUXO,
                                      @V_AJCNT_CDCLASSFINA,
                                      @V_VALORCALCULADO,
                                      0;
      END
      ELSE BEGIN
         EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJCNT_CDEMFAJCNTR,
                                      @V_AJCNT_CDFIMFAJCNTR,
                                      @V_AJCNT_DTMOVFLUXO,
                                      @V_AJCNT_IDMOVFLUXO,
                                      @V_AJCNT_CDCLASSFINA,
                                      @V_AJCNT_VRAJUSTEREC,
                                      0;
      END;

      DELETE FROM LANCCONT
       WHERE CDEMPRESA  = @V_AJCNT_CDECTBAJREC
         AND NRLANCCONT = @V_AJCNT_NRLCTBAJREC;

      DELETE FROM AJCTRECEBER
       WHERE CDFILIAL     = @P_CDFILIAL
         AND NRLANCTONF   = @P_NRLANCTONF
         AND NRSEQVENREC  = @V_AJCNT_NRSEQVENREC
         AND NRPARCELAREC = @V_AJCNT_NRPARCELAREC
         AND DTAJUSTEREC  = @V_AJCNT_DTAJUSTEREC
         AND CDAJUCTREC   = @V_AJCNT_CDAJUCTREC;

      FETCH NEXT FROM C_AJUSTECNT INTO
      @V_AJCNT_CDFILIAL,
      @V_AJCNT_NRLANCTONF,
      @V_AJCNT_NRSEQVENREC,
      @V_AJCNT_NRPARCELAREC,
      @V_AJCNT_DTAJUSTEREC,
      @V_AJCNT_CDAJUCTREC,
      @V_AJCNT_IDAJUCTREC,
      @V_AJCNT_VRAJUSTEREC,
      @V_AJCNT_CDCLASSFINA,
      @V_AJCNT_CDEMFAJCNTR,
      @V_AJCNT_CDFIMFAJCNTR,
      @V_AJCNT_DTMOVFLUXO,
      @V_AJCNT_IDMOVFLUXO;
   END;
   CLOSE C_AJUSTECNT;
   DEALLOCATE C_AJUSTECNT;

   /*Deleta o rateio*/
   DELETE FROM RATCTRECEBER
    WHERE CDFILIAL   = @P_CDFILIAL
      AND NRLANCTONF = @P_NRLANCTONF;

   SELECT @V_CDEMPRESA  = MAX(CDEMPRESA),  @V_CDFIMOVFLREC = MAX(CDFIMOVFLREC), @V_DTATUAVENREC = MAX(DTATUAVENREC),
          @V_IDMOVFLUXO = MAX(IDMOVFLUXO), @V_CDCLASSFINA  = MAX(CDCLASSFINA),  @V_VRORIGREC    = MAX(VRORIGREC)
     FROM CONTARECEBER
    WHERE CDFILIAL   = @P_CDFILIAL
      AND NRLANCTONF = @P_NRLANCTONF;

   SET @V_VALORCALCULADO = @V_VRORIGREC * -1;
   EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CDEMPRESA,
                                @V_CDFIMOVFLREC,
                                @V_DTATUAVENREC,
                                @V_IDMOVFLUXO,
                                @V_CDCLASSFINA,
                                @V_VALORCALCULADO,
                                0;

   DECLARE C_BOLETOS CURSOR FOR
   SELECT CDFILIBOLREC, NRLANBOLREC, CDFILIAL, NRSEQVENREC, NRPARCELAREC,
          CDEMPRESA, CDFIMOVFLREC, CDCLASSFINA, DTMOVFLUXO, IDMOVFLUXO
     FROM CONTARECEBER
    WHERE (CDFILIAL   = @P_CDFILIAL)
      AND (NRLANCTONF = @P_NRLANCTONF);

   OPEN C_BOLETOS;
   FETCH NEXT FROM C_BOLETOS INTO
   @V_BOLETOS_CDFILIBOLREC,
   @V_BOLETOS_NRLANBOLREC,
   @V_BOLETOS_CDFILIAL,
   @V_BOLETOS_NRSEQVENREC,
   @V_BOLETOS_NRPARCELAREC,
   @V_BOLETOS_CDEMPRESA,
   @V_BOLETOS_CDFIMOVFLREC,
   @V_BOLETOS_CDCLASSFINA,
   @V_BOLETOS_DTMOVFLUXO,
   @V_BOLETOS_IDMOVFLUXO;

   WHILE(@@FETCH_STATUS = 0) BEGIN
      DECLARE C_AJUSTEBOL CURSOR FOR
      SELECT CDFILIAL, NRLANBOLREC, CDAJUCTREC, VRAJBOLREC
        FROM AJBOLREC
       WHERE (CDFILIAL = @V_BOLETOS_CDFILIBOLREC)
         AND (NRLANBOLREC = @V_BOLETOS_NRLANBOLREC);
      OPEN C_AJUSTEBOL;
      FETCH NEXT FROM C_AJUSTEBOL INTO
      @V_AJUSTEBOL_CDFILIAL,
      @V_AJUSTEBOL_NRLANBOLREC,
      @V_AJUSTEBOL_CDAJUCTREC,
      @V_AJUSTEBOL_VRAJBOLREC;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SELECT @V_IDAJUCTREC = MAX(IDAJUCTREC)
           FROM TIPOAJRECEBER
          WHERE CDAJUCTREC = @V_AJUSTEBOL_CDAJUCTREC;

         IF @V_IDAJUCTREC = 'D' BEGIN
            SET @V_VRAJUSTE = @V_AJUSTEBOL_VRAJBOLREC;
         END
         ELSE BEGIN
            SET @V_VRAJUSTE = @V_AJUSTEBOL_VRAJBOLREC * -1;
         END;

         EXEC ATUALIZA_FLUXO_DE_CAIXA @V_BOLETOS_CDEMPRESA,
                                      @V_BOLETOS_CDFIMOVFLREC,
                                      @V_BOLETOS_DTMOVFLUXO,
                                      @V_BOLETOS_IDMOVFLUXO,
                                      @V_BOLETOS_CDCLASSFINA,
                                      @V_VRAJUSTE,
                                      0;

         DELETE FROM MOVFXAJBOLR
          WHERE CDEMPRESA = @V_BOLETOS_CDEMPRESA AND
                CDFILIAL = @V_AJUSTEBOL_CDFILIAL AND
                CDCLASSFINA = @V_BOLETOS_CDCLASSFINA AND
                DTMOVFLUXO = @V_BOLETOS_DTMOVFLUXO AND
                IDMOVFLUXO = @V_BOLETOS_IDMOVFLUXO AND
                CDFILIBOLREC = @V_BOLETOS_CDFIMOVFLREC AND
                NRLANBOLREC = @V_AJUSTEBOL_NRLANBOLREC AND
                CDAJUCTREC = @V_AJUSTEBOL_CDAJUCTREC;

         DELETE FROM AJBOLREC
          WHERE (CDFILIAL    = @V_AJUSTEBOL_CDFILIAL   )
            AND (NRLANBOLREC = @V_AJUSTEBOL_NRLANBOLREC)
            AND (CDAJUCTREC  = @V_AJUSTEBOL_CDAJUCTREC);

         FETCH NEXT FROM C_AJUSTEBOL INTO
         @V_AJUSTEBOL_CDFILIAL,
         @V_AJUSTEBOL_NRLANBOLREC,
         @V_AJUSTEBOL_CDAJUCTREC,
         @V_AJUSTEBOL_VRAJBOLREC;
      END;
      CLOSE C_AJUSTEBOL;
      DEALLOCATE C_AJUSTEBOL;
      /*Exclui a conta*/
      DELETE FROM CONTARECEBER
       WHERE CDFILIAL     = @P_CDFILIAL
         AND NRLANCTONF   = @P_NRLANCTONF
         AND NRSEQVENREC  = @V_BOLETOS_NRSEQVENREC
         AND NRPARCELAREC = @V_BOLETOS_NRPARCELAREC;

      /*Exclui o boleto*/
      DELETE FROM BOLETRECEBER
       WHERE CDFILIAL    = @V_BOLETOS_CDFILIBOLREC
         AND NRLANBOLREC = @V_BOLETOS_NRLANBOLREC;

      FETCH NEXT FROM C_BOLETOS INTO
      @V_BOLETOS_CDFILIBOLREC,
      @V_BOLETOS_NRLANBOLREC,
      @V_BOLETOS_CDFILIAL,
      @V_BOLETOS_NRSEQVENREC,
      @V_BOLETOS_NRPARCELAREC,
      @V_BOLETOS_CDEMPRESA,
      @V_BOLETOS_CDFIMOVFLREC,
      @V_BOLETOS_CDCLASSFINA,
      @V_BOLETOS_DTMOVFLUXO,
      @V_BOLETOS_IDMOVFLUXO;
   END;

   CLOSE C_BOLETOS;
   DEALLOCATE C_BOLETOS;

   SELECT @V_NRCHEQUEVEND = MAX(NRCHEQUEVEND), @V_CDBANCHEQVEN = MAX(CDBANCHEQVEN),
          @V_CDAGECHEQVEN = MAX(CDAGECHEQVEN), @V_CDCNTCHEQVEN = MAX(CDCNTCHEQVEN)
     FROM MOVCAIXA
    WHERE CDFILIALNF = @P_CDFILIAL
      AND NRLANCTONF = @P_NRLANCTONF;

   /*Exclui os cheques recebidos*/
   IF @V_NRCHEQUEVEND IS NOT NULL BEGIN
      DELETE FROM CHEQUERECE
       WHERE NRCHEQUERECE = @V_NRCHEQUEVEND
         AND CDBANCHEQREC = @V_CDBANCHEQVEN
         AND CDAGECHEQREC = @V_CDAGECHEQVEN
         AND CDCNTCHEQREC = @V_CDCNTCHEQVEN;
   END;

   /*Atualiza as informaes da Movimentao de caixa*/  
   UPDATE MOVCAIXA
      SET NRLANCTONF = NULL,
          CDFILIALNF = NULL
    WHERE CDFILIALNF = @P_CDFILIAL
      AND NRLANCTONF = @P_NRLANCTONF;

   SELECT @V_CDEMPRESA = MAX(CDEMPRESA), @V_NRLANCTBDOC = MAX(NRLANCTBDOC)
     FROM NOTAFISCAL
    WHERE CDFILIAL   = @P_CDFILIAL
      AND NRLANCTONF = @P_NRLANCTONF;

   DELETE FROM LANCCONT
    WHERE CDEMPRESA  = @V_CDEMPRESA
      AND NRLANCCONT = @V_NRLANCTBDOC;

   DELETE FROM NOTAFISCAL
    WHERE CDFILIAL   = @P_CDFILIAL
      AND NRLANCTONF = @P_NRLANCTONF;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'CANCELA_EXPORTA_PDV_FINANC','5.50.xxx';
GO